#region Copyright Syncfusion Inc. 2001 -2004
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
//  Copyright Syncfusion Inc. All rights reserved. Use of this code is subject to the terms of our 
//  license. A copy of the current license can be obtained at any time by e-mailing licensing@syncfusion.com. 
//  Re-distribution in any form is strictly prohibited. Any infringement will be prosecuted under applicable laws. 
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////// 
#endregion 
 
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Diagram;

namespace ZoomRichText
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Diagram.Controls.Diagram diagram;
		private Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager mainFrameBarManager;
		private Syncfusion.Windows.Forms.Tools.XPMenus.Bar bar1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem1;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem2;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem3;
		private Syncfusion.Windows.Forms.Tools.XPMenus.BarItem barItem4;
		private System.ComponentModel.IContainer components;

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			// Register a custom richtext tool that draws a richt text as WMF image
			RichTextTool rtftool = new RichTextTool("ZoomRichTextTool");
			rtftool.RichTextFactory = new RichTextFactory(ZoomRichTextFactory);
			this.diagram.Controller.RegisterTool(rtftool);
		}

		protected RichTextNode ZoomRichTextFactory(RectangleF bounds, string text)
		{
			ZoomRichTextNode rtfNode = new ZoomRichTextNode(text);
			rtfNode.Bounds = bounds;
			return rtfNode;
		}


		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.diagram = new Syncfusion.Windows.Forms.Diagram.Controls.Diagram();
			this.mainFrameBarManager = new Syncfusion.Windows.Forms.Tools.XPMenus.MainFrameBarManager(this.components, this);
			this.bar1 = new Syncfusion.Windows.Forms.Tools.XPMenus.Bar(this.mainFrameBarManager, "Edit");
			this.barItem1 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem2 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem3 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			this.barItem4 = new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem();
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).BeginInit();
			this.SuspendLayout();
			// 
			// diagram
			// 
			this.diagram.AccelerateScrolling = Syncfusion.Windows.Forms.AccelerateScrollingBehavior.None;
			this.diagram.AllowDrop = true;
			// 
			// diagram.Controller
			// 
			this.diagram.Controller.MaxHistory = 256;
			this.diagram.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diagram.HScroll = true;
			this.diagram.LayoutManager = null;
			this.diagram.Location = new System.Drawing.Point(0, 26);
			// 
			// diagram.Model
			// 
			this.diagram.Model.BackgroundStyle.Color = System.Drawing.Color.White;
			this.diagram.Model.BackgroundStyle.Type = Syncfusion.Windows.Forms.Diagram.BackgroundStyle.BackgroundType.Solid;
			this.diagram.Model.BoundaryConstraintsEnabled = true;
			this.diagram.Model.Height = 500F;
			this.diagram.Model.Name = "Model";
			this.diagram.Model.RenderingStyle.Properties = this.diagram.Model;
			this.diagram.Model.RenderingStyle.SmoothingMode = System.Drawing.Drawing2D.SmoothingMode.Default;
			this.diagram.Model.Width = 500F;
			this.diagram.Model.PropertyChanged += new Syncfusion.Windows.Forms.Diagram.PropertyEventHandler(this.diagram_Model_PropertyChanged);
			this.diagram.Name = "diagram";
			this.diagram.NudgeIncrement = 1F;
			this.diagram.ScrollGranularity = 0.5F;
			this.diagram.Size = new System.Drawing.Size(536, 380);
			this.diagram.SmartSizeBox = false;
			this.diagram.TabIndex = 0;
			this.diagram.Text = "diagram1";
			// 
			// diagram.View
			// 
			this.diagram.View.Grid.Visible = true;
			this.diagram.View.HorizontalRuler.Visible = true;
			this.diagram.View.PasteOffsetX = 10;
			this.diagram.View.PasteOffsetY = 10;
			this.diagram.View.VerticalRuler.Visible = true;
			this.diagram.VScroll = true;
			// 
			// mainFrameBarManager
			// 
			this.mainFrameBarManager.BarPositionInfo = ((System.IO.MemoryStream)(resources.GetObject("mainFrameBarManager.BarPositionInfo")));
			this.mainFrameBarManager.Bars.Add(this.bar1);
			this.mainFrameBarManager.Categories.Add("Edit");
			this.mainFrameBarManager.CurrentBaseFormType = "System.Windows.Forms.Form";
			this.mainFrameBarManager.Form = this;
			this.mainFrameBarManager.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																											 this.barItem1,
																											 this.barItem2,
																											 this.barItem3,
																											 this.barItem4});
			this.mainFrameBarManager.LargeImageList = null;
			this.mainFrameBarManager.ResetCustomization = false;
			// 
			// bar1
			// 
			this.bar1.BarName = "Edit";
			this.bar1.BarStyle = ((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle)((((((Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.AllowQuickCustomizing | Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.MultiLine) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.Visible) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.UseWholeRow) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.DrawDragBorder) 
				| Syncfusion.Windows.Forms.Tools.XPMenus.BarStyle.TextBelowImage)));
			this.bar1.Items.AddRange(new Syncfusion.Windows.Forms.Tools.XPMenus.BarItem[] {
																							  this.barItem1,
																							  this.barItem2,
																							  this.barItem3,
																							  this.barItem4});
			this.bar1.Manager = this.mainFrameBarManager;
			// 
			// barItem1
			// 
			this.barItem1.CategoryIndex = 0;
			this.barItem1.ID = "CustomRectTool";
			this.barItem1.Text = "RichText";
			this.barItem1.Click += new System.EventHandler(this.barItem1_Click);
			// 
			// barItem2
			// 
			this.barItem2.CategoryIndex = 0;
			this.barItem2.ID = "ZoomTool";
			this.barItem2.MergeOrder = 1;
			this.barItem2.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.TextOnly;
			this.barItem2.Text = "Zoom";
			this.barItem2.Click += new System.EventHandler(this.barItem2_Click);
			// 
			// barItem3
			// 
			this.barItem3.CategoryIndex = 0;
			this.barItem3.ID = "Pan";
			this.barItem3.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.TextOnly;
			this.barItem3.Text = "Pan";
			this.barItem3.Click += new System.EventHandler(this.barItem3_Click);
			// 
			// barItem4
			// 
			this.barItem4.CategoryIndex = 0;
			this.barItem4.ID = "Select";
			this.barItem4.PaintStyle = Syncfusion.Windows.Forms.Tools.XPMenus.PaintStyle.TextOnly;
			this.barItem4.Text = "Select";
			this.barItem4.Click += new System.EventHandler(this.barItem4_Click);
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(536, 406);
			this.Controls.Add(this.diagram);
			this.Name = "MainForm";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Show;
			this.Text = "Dynamic Symbol";
			((System.ComponentModel.ISupportInitialize)(this.mainFrameBarManager)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new MainForm());
		}

		private void diagram_Model_PropertyChanged(object sender, Syncfusion.Windows.Forms.Diagram.PropertyEventArgs evtArgs)
		{
			this.diagram.View.Update();
		}

		private void barItem1_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("ZoomRichTextTool");
		}

		private void barItem2_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("ZoomTool");
		}

		private void barItem4_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("SelectTool");
		}

		private void barItem3_Click(object sender, System.EventArgs e)
		{
			this.diagram.ActivateTool("PanTool");
		}
	}
}
